Package org.codehaus.groovy.ast

## Class FieldNode

- java.lang.Object
- - org.codehaus.groovy.ast.ASTNode
  - - org.codehaus.groovy.ast.AnnotatedNode
    - - org.codehaus.groovy.ast.FieldNode

- All Implemented Interfaces:
    `GroovydocHolder<AnnotatedNode>`, `NodeMetaDataHandler`, `Variable`, `org.objectweb.asm.Opcodes`

      public class FieldNode
      extends AnnotatedNode
      implements org.objectweb.asm.Opcodes, Variable

  Represents a field (member variable)

- - ### Field Summary

    - ### Fields inherited from interface groovy.lang.groovydoc.GroovydocHolder

      `DOC_COMMENT`

    - ### Fields inherited from interface org.objectweb.asm.Opcodes

      `AALOAD, AASTORE, ACC_ABSTRACT, ACC_ANNOTATION, ACC_BRIDGE, ACC_DEPRECATED, ACC_ENUM, ACC_FINAL, ACC_INTERFACE, ACC_MANDATED, ACC_MODULE, ACC_NATIVE, ACC_OPEN, ACC_PRIVATE, ACC_PROTECTED, ACC_PUBLIC, ACC_RECORD, ACC_STATIC, ACC_STATIC_PHASE, ACC_STRICT, ACC_SUPER, ACC_SYNCHRONIZED, ACC_SYNTHETIC, ACC_TRANSIENT, ACC_TRANSITIVE, ACC_VARARGS, ACC_VOLATILE, ACONST_NULL, ALOAD, ANEWARRAY, ARETURN, ARRAYLENGTH, ASM4, ASM5, ASM6, ASM7, ASM8, ASM9_EXPERIMENTAL, ASTORE, ATHROW, BALOAD, BASTORE, BIPUSH, CALOAD, CASTORE, CHECKCAST, D2F, D2I, D2L, DADD, DALOAD, DASTORE, DCMPG, DCMPL, DCONST_0, DCONST_1, DDIV, DLOAD, DMUL, DNEG, DOUBLE, DREM, DRETURN, DSTORE, DSUB, DUP, DUP_X1, DUP_X2, DUP2, DUP2_X1, DUP2_X2, F_APPEND, F_CHOP, F_FULL, F_NEW, F_SAME, F_SAME1, F2D, F2I, F2L, FADD, FALOAD, FASTORE, FCMPG, FCMPL, FCONST_0, FCONST_1, FCONST_2, FDIV, FLOAD, FLOAT, FMUL, FNEG, FREM, FRETURN, FSTORE, FSUB, GETFIELD, GETSTATIC, GOTO, H_GETFIELD, H_GETSTATIC, H_INVOKEINTERFACE, H_INVOKESPECIAL, H_INVOKESTATIC, H_INVOKEVIRTUAL, H_NEWINVOKESPECIAL, H_PUTFIELD, H_PUTSTATIC, I2B, I2C, I2D, I2F, I2L, I2S, IADD, IALOAD, IAND, IASTORE, ICONST_0, ICONST_1, ICONST_2, ICONST_3, ICONST_4, ICONST_5, ICONST_M1, IDIV, IF_ACMPEQ, IF_ACMPNE, IF_ICMPEQ, IF_ICMPGE, IF_ICMPGT, IF_ICMPLE, IF_ICMPLT, IF_ICMPNE, IFEQ, IFGE, IFGT, IFLE, IFLT, IFNE, IFNONNULL, IFNULL, IINC, ILOAD, IMUL, INEG, INSTANCEOF, INTEGER, INVOKEDYNAMIC, INVOKEINTERFACE, INVOKESPECIAL, INVOKESTATIC, INVOKEVIRTUAL, IOR, IREM, IRETURN, ISHL, ISHR, ISTORE, ISUB, IUSHR, IXOR, JSR, L2D, L2F, L2I, LADD, LALOAD, LAND, LASTORE, LCMP, LCONST_0, LCONST_1, LDC, LDIV, LLOAD, LMUL, LNEG, LONG, LOOKUPSWITCH, LOR, LREM, LRETURN, LSHL, LSHR, LSTORE, LSUB, LUSHR, LXOR, MONITORENTER, MONITOREXIT, MULTIANEWARRAY, NEW, NEWARRAY, NOP, NULL, POP, POP2, PUTFIELD, PUTSTATIC, RET, RETURN, SALOAD, SASTORE, SIPUSH, SOURCE_DEPRECATED, SOURCE_MASK, SWAP, T_BOOLEAN, T_BYTE, T_CHAR, T_DOUBLE, T_FLOAT, T_INT, T_LONG, T_SHORT, TABLESWITCH, TOP, UNINITIALIZED_THIS, V_PREVIEW, V1_1, V1_2, V1_3, V1_4, V1_5, V1_6, V1_7, V1_8, V10, V11, V12, V13, V14, V15, V9`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor | Description
    --- | --- | ---
    `protected` | `FieldNode()` |
    `` | `FieldNode​(String name, int modifiers, ClassNode type, ClassNode owner, Expression initialValueExpression)` |

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods Deprecated Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `Expression` | `getInitialExpression()` | expression used to initialize the variable or null of there is no initialization.
    `Expression` | `getInitialValueExpression()` |
    `int` | `getModifiers()` |
    `String` | `getName()` | the name of the variable
    `ClassNode` | `getOriginType()` | the type before wrapping primitives type of the variable
    `ClassNode` | `getOwner()` |
    `ClassNode` | `getType()` | the type of the variable
    `boolean` | `hasInitialExpression()` | returns true if there is an initialization expression
    `boolean` | `isClosureSharedVariable()` | Deprecated.
    `boolean` | `isDynamicTyped()` |
    `boolean` | `isEnum()` |
    `boolean` | `isFinal()` |
    `boolean` | `isHolder()` |
    `boolean` | `isInStaticContext()` | returns true if this variable is used in a static context.
    `boolean` | `isPrivate()` |
    `boolean` | `isProtected()` |
    `boolean` | `isPublic()` |
    `boolean` | `isStatic()` |
    `boolean` | `isVolatile()` |
    `static FieldNode` | `newStatic​(Class theClass, String name)` |
    `void` | `rename​(String name)` |
    `void` | `setClosureSharedVariable​(boolean inClosure)` | Deprecated.
    `void` | `setHolder​(boolean holder)` |
    `void` | `setInitialValueExpression​(Expression initialValueExpression)` |
    `void` | `setModifiers​(int modifiers)` |
    `void` | `setOriginType​(ClassNode cn)` |
    `void` | `setOwner​(ClassNode owner)` |
    `void` | `setType​(ClassNode type)` |

    - ### Methods inherited from class org.codehaus.groovy.ast.AnnotatedNode

      `addAnnotation, addAnnotations, getAnnotations, getAnnotations, getDeclaringClass, getGroovydoc, getInstance, hasNoRealSourcePosition, isSynthetic, setDeclaringClass, setHasNoRealSourcePosition, setSynthetic`

    - ### Methods inherited from class org.codehaus.groovy.ast.ASTNode

      `copyNodeMetaData, getColumnNumber, getLastColumnNumber, getLastLineNumber, getLineNumber, getMetaDataMap, getText, hashCode, setColumnNumber, setLastColumnNumber, setLastLineNumber, setLineNumber, setMetaDataMap, setSourcePosition, visit`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface org.codehaus.groovy.ast.NodeMetaDataHandler

      `copyNodeMetaData, getNodeMetaData, getNodeMetaData, getNodeMetaData, putNodeMetaData, removeNodeMetaData, setNodeMetaData`

- - ### Constructor Detail

    - #### FieldNode

          protected FieldNode()

    - #### FieldNode

          public FieldNode​(String name,
                           int modifiers,
                           ClassNode type,
                           ClassNode owner,
                           Expression initialValueExpression)

  - ### Method Detail

    - #### newStatic

          public static FieldNode newStatic​(Class theClass,
                                            String name)
                                     throws SecurityException,
                                            NoSuchFieldException

      Throws:
        `SecurityException`
        `NoSuchFieldException`

    - #### getInitialExpression

          public Expression getInitialExpression()

      Description copied from interface: `Variable`
      expression used to initialize the variable or null of there is no initialization.
      Specified by:
        `getInitialExpression` in interface `Variable`

    - #### getModifiers

          public int getModifiers()

      Specified by:
        `getModifiers` in interface `Variable`

    - #### getName

          public String getName()

      Description copied from interface: `Variable`
      the name of the variable
      Specified by:
        `getName` in interface `Variable`

    - #### getType

          public ClassNode getType()

      Description copied from interface: `Variable`
      the type of the variable
      Specified by:
        `getType` in interface `Variable`

    - #### setType

          public void setType​(ClassNode type)

    - #### getOwner

          public ClassNode getOwner()

    - #### isHolder

          public boolean isHolder()

    - #### setHolder

          public void setHolder​(boolean holder)

    - #### isDynamicTyped

          public boolean isDynamicTyped()

      Specified by:
        `isDynamicTyped` in interface `Variable`

    - #### setModifiers

          public void setModifiers​(int modifiers)

    - #### isStatic

          public boolean isStatic()

      Returns:
        true if the field is static

    - #### isEnum

          public boolean isEnum()

      Returns:
        true if the field is an enum

    - #### isFinal

          public boolean isFinal()

      Returns:
        true if the field is final

    - #### isVolatile

          public boolean isVolatile()

      Returns:
        true if the field is volatile

    - #### isPublic

          public boolean isPublic()

      Returns:
        true if the field is public

    - #### isProtected

          public boolean isProtected()

      Returns:
        true if the field is protected

    - #### isPrivate

          public boolean isPrivate()

      Returns:
        true if the field is private
      Since:
        2.5.0

    - #### setOwner

          public void setOwner​(ClassNode owner)

      Parameters:
        `owner` - The owner to set.

    - #### hasInitialExpression

          public boolean hasInitialExpression()

      Description copied from interface: `Variable`
      returns true if there is an initialization expression
      Specified by:
        `hasInitialExpression` in interface `Variable`

    - #### isInStaticContext

          public boolean isInStaticContext()

      Description copied from interface: `Variable`
      returns true if this variable is used in a static context. A static context is any static initializer block, when this variable is declared as static or when this variable is used in a static method
      Specified by:
        `isInStaticContext` in interface `Variable`

    - #### getInitialValueExpression

          public Expression getInitialValueExpression()

    - #### setInitialValueExpression

          public void setInitialValueExpression​(Expression initialValueExpression)

    - #### isClosureSharedVariable

          @Deprecated
          public boolean isClosureSharedVariable()

      Deprecated.
      Specified by:
        `isClosureSharedVariable` in interface `Variable`

    - #### setClosureSharedVariable

          @Deprecated
          public void setClosureSharedVariable​(boolean inClosure)

      Deprecated.
      Specified by:
        `setClosureSharedVariable` in interface `Variable`

    - #### getOriginType

          public ClassNode getOriginType()

      Description copied from interface: `Variable`
      the type before wrapping primitives type of the variable
      Specified by:
        `getOriginType` in interface `Variable`

    - #### setOriginType

          public void setOriginType​(ClassNode cn)

    - #### rename

          public void rename​(String name)